/* Component Parser Version 1.7 -- Generated Code */
package testcases.scss;
import component.system.*;
import java.util.*;
import java.io.*;
import java.net.*;

 class ComponentEntry
{private String identifier;public String instance;public String blueprint;public String location;public String argument;private boolean ready;private boolean beingcreated;public void setBeingCreated () 
{
ready=false;
beingcreated=true;}
 public void setDead () 
{
ready=false;
beingcreated=false;}
 public ComponentEntry ( String in,  String blue,  String arg){identifier=in; instance=in; blueprint=blue;  int pos = in.indexOf(":"); if (pos!=-1)
location=in.substring(0, pos); ready=false; beingcreated=false; argument=arg; }public boolean isName ( String n) 
{
return instance.compareTo(n)==0;}
 public String name () 
{
return instance;}
 public String toString () 
{
return name();}
 public boolean isReady () 
{
return ready;}
 public void setReady () 
{
ready=true;
beingcreated=false;}
 public boolean atLocation ( String l) 
{
if (location==null)
return true;
if (l==null)
return true;
return location.compareTo(l)==0;}
 public boolean atUnknownLocation () 
{
return location==null;}
 public boolean atExactLocation ( String l) 
{
if (location==null)
return false;
return location.compareTo(l)==0;}
 public boolean isBeingCreated () 
{
return beingcreated;}
 }

;
final class ConnectionEntry extends component.system.Global

{public ComponentEntry c1;public ComponentEntry c2;public String p1;public String p2;public boolean created;public ConnectionEntry ( ComponentEntry C1,  ComponentEntry C2,  String a,  String b){c1=C1; c2=C2; p1=a; p2=b; created=false; if (c1==null)
Fatal("controller: connectionentry creation c1 == null"); if (c2==null)
Fatal("controller: connectionentry creation c2 == null"); }public String id1 () 
{
return c1.name()+"/"+p1;}
 public String id2 () 
{
return c2.name()+"/"+p2;}
 public boolean ready () 
{
return c1.isReady()&&c2.isReady();}
 }

;
 class ConnectionAcceptor extends Global
 implements Runnable

{ ServerSocket listenSocket; Controller component;public ConnectionAcceptor ( int p,  Controller c){try 
{
listenSocket=new ServerSocket (p);}
catch ( Exception e)
{
Fatal("controller: listen socket creation failed ", e);}
 component=c; new Thread (this).start(); }public String retrieveAddr () 
{
try 
{
 String answer = InetAddress.getLocalHost().getHostAddress()+":"+listenSocket.getLocalPort();
if (InetAddress.getLocalHost().getHostAddress().compareTo("127.0.0.1")==0)
Fatal("localhost is wrong, pleased fix it");
return answer;}
catch ( Exception e)
{
Fatal("retrieving listen socket address failure ", e);}

return null;}
 public void run () 
{
while( true)
{
 Socket cs = null;
try 
{
cs=listenSocket.accept();}
catch ( Exception e)
{
Fatal("controller: accept failed ", e);}

 String machine = null;
 String connectWith = null;
 String connectFrom = null;
 ObjectOutputStream oo = null;
 ObjectInputStream oi = null;
try 
{
oo=new ObjectOutputStream (cs.getOutputStream());
oi=new ObjectInputStream (cs.getInputStream());
machine=(String)oi.readObject();
connectFrom=(String)oi.readObject();
connectWith=(String)oi.readObject();}
catch ( Exception e)
{
Fatal("controller: incoming connection failed ", e);}

component.setupIncomingConnection(oo, oi, machine, connectFrom, connectWith);}
}
 }

;
 public class Controller extends component.system.Component

{ public MultiPort  controller; public Port  masterport;private List static_connections;private List dynamic_connections;private List static_components;private List dynamic_components;private TreeMap machines;private String masterLocation;private String location;private String master;private boolean isMaster;private ConnectionAcceptor connectionAcceptor;static final public int NOTHING = -1;static final public int STANDARD = 0;static final public int DYNAMIC = 1;static final public int CONNECTIONS = 2;static final public int TRACING = 3;static final public int INTERNALS = 4;static final private int loglevel = CONNECTIONS;static final String green = "[01;32m";static final String yellow = "[01;33m";static final String grey = "[01;30m";static final String blue = "[01;34m";static final String darkblue = "[00;34m";static final String red = "[01;31m [red]";static final String darkred = "[00;31m";static final String normal = "[00;26m";static final String white = "[01;36m";static public void Log ( int level,  String txt) 
{
LogCont(level, txt);
LogDone();}
 static public void LogDone () 
{
System.out.print(normal);
System.out.flush();}
 static public void LogCont ( int level,  String txt) 
{
if (level<=loglevel)
{
 String color;
switch (level)
{
case DYNAMIC : 
color=green;
break;
case CONNECTIONS : 
color=yellow;
break;
case STANDARD : 
color=blue;
break;
case INTERNALS : 
default  : 
color=grey;}

System.out.println(color+"controller: "+txt);}
}
 public Controller (){machines=new TreeMap (); static_connections=new LinkedList (); dynamic_connections=new LinkedList (); static_components=new LinkedList (); dynamic_components=new LinkedList (); controller=createMultiPort("Controller", this); connectionAcceptor=null; masterport=createPort("masterport"); isMaster=false; location=null; masterLocation=null; master=null; }static private int connectionproxies = 0;static public int getPort ( String a) 
{
 String portstr = a.substring(a.indexOf(":")+1);
 int res = Integer.parseInt(portstr);
Log(INTERNALS, "getPort("+a+") = "+res);
return res;}
 synchronized public void setupIncomingConnection ( ObjectOutputStream oo,  ObjectInputStream oi,  String machine,  String outside,  String inside) 
{
 Message inmessage = new Message ();
 Message outmessage = inmessage.copy();
 String blueprint = "testcases.scss.ConnectionProxy";
 String instance = location+":connectionproxy"+(connectionproxies++);
addPendingComponent(dynamic_components, blueprint, instance, true);
{ outmessage.putField("Invoke","Init");
outmessage.putField("Output",oo);
outmessage.putField("Input",oi);
(createComponent(blueprint, instance)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
addPendingConnection(dynamic_connections, inside, instance+"/inside");
if (isMaster)
Log(CONNECTIONS, "'"+outside+"' ("+machine+") wants to connect with '"+inside);}
 protected InetAddress getInetAddress ( String str) 
{
 InetAddress ia = null;
try 
{
str=str.substring(0, str.indexOf(':'));
ia=InetAddress.getByName(str);}
catch ( Exception e)
{
Fatal("Unable to look up address "+str);}

Log(INTERNALS, "inetaddress of "+str+" is "+ia);
return ia;}
 synchronized protected void setupOutgoingConnection ( String inside,  String outside,  String outsideplace) 
{
 Socket s = null;
 ObjectOutputStream oo = null;
 ObjectInputStream oi = null;
if (outsideplace==null)
Fatal("setupOutgoingConnection; outsideplace == null");
try 
{
s=new Socket (getInetAddress(outsideplace), getPort(outsideplace));
oo=new ObjectOutputStream (s.getOutputStream());
oi=new ObjectInputStream (s.getInputStream());
oo.writeObject(location);
oo.writeObject(inside);
oo.writeObject(outside);}
catch ( Exception e)
{
Fatal("controller: outgoing connection setup failed", e);}

 Message inmessage = new Message ();
 Message outmessage = inmessage.copy();
 String blueprint = "testcases.scss.ConnectionProxy";
 String instance = location+":connectionproxy"+(connectionproxies++);
addPendingComponent(dynamic_components, blueprint, instance, true);
{ outmessage.putField("Invoke","Init");
outmessage.putField("Output",oo);
outmessage.putField("Input",oi);
(createComponent(blueprint, instance)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
addPendingConnection(dynamic_connections, inside, instance+"/inside");}
 protected void setupListening () 
{
Log(TRACING, "setting up incoming link");
if (isMaster)
connectionAcceptor=new ConnectionAcceptor (getPort(masterLocation), this);
else connectionAcceptor=new ConnectionAcceptor (0, this);}
 protected void setupLinkToMaster () 
{
Log(TRACING, "setting up outgoing link to "+masterLocation);
setupOutgoingConnection(masterport.toString(), "Controller/controller", masterLocation);}
 static private String topWord ( String w) 
{
while( w.indexOf(" ")==0)
w=w.substring(1);
if (w.indexOf(" ")<0)
return w;
return w.substring(0, w.indexOf(" "));}
 static private String popWord ( String w) 
{
while( w.indexOf(" ")==0)
w=w.substring(1);
 String rest = w.substring(w.indexOf(" ")+1);
return rest;}
 private void parseLine ( String line,  Message inmessage) 
{
line=line+" ";
 String word = topWord(line);
if (word.compareTo("COMPONENT")==0)
{
line=popWord(line);
 String blueprint = topWord(line);
line=popWord(line);
 String instance = topWord(line);
line=popWord(line);
 String argument = topWord(line);
addPendingComponent(static_components, blueprint, instance, argument, false);}

if (word.compareTo("CONNECT")==0)
{
line=popWord(line);
 String a = topWord(line);
line=popWord(line);
 String b = topWord(line);
addPendingConnection(static_connections, a, b);}

if (word.compareTo("CONTROLLER")==0)
{
line=popWord(line);
master=topWord(line);
line=popWord(line);
masterLocation=topWord(line);}
}
 protected void addPendingComponent ( List components,  String blueprint,  String instance,  boolean creating) 
{
addPendingComponent(components, blueprint, instance, null, creating);}
 protected void addPendingComponent ( List components,  String blueprint,  String instance,  String argument,  boolean creating) 
{
 ComponentEntry cet = new ComponentEntry (instance, blueprint, argument);
if (creating)
cet.setBeingCreated();
components.add(cet);}
 protected void checkPendingComponents () 
{
checkPendingComponents(static_components);
checkPendingComponents(dynamic_components);}
 protected void checkPendingComponents ( List components) 
{
 Iterator it = components.iterator();
while( it.hasNext())
{
 ComponentEntry cet = (ComponentEntry)it.next();
if (cet.isReady()||cet.isBeingCreated())
continue;
if (cet.atLocation(location))
{
 Message inmessage = new Message ();
 Message outmessage = inmessage.copy();
Log(STANDARD, "creating "+cet.instance);
if (cet.argument==null)
{
{ outmessage.putField("Invoke","Init");
(createComponent(cet.blueprint, cet.instance)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}

else {
{ outmessage.putField("Invoke","Init");
outmessage.putField("Argument",cet.argument);
(createComponent(cet.blueprint, cet.instance)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}

cet.setBeingCreated();
continue;}

else if (components==dynamic_components&&isMaster)
{
 Port mp = findMachinePort(cet.location);
if (mp==null)
continue;
 Message inmessage = new Message ();
 Message outmessage = inmessage.copy();
Log(STANDARD, "remote creating "+cet.instance);
{ outmessage.putField("Invoke","IntantiateComponent");
outmessage.putField("BluePrint",cet.blueprint);
outmessage.putField("Instance",cet.instance);
(mp).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
cet.setBeingCreated();}
}
}
 protected void removeMachine ( String machine) 
{
 Iterator it = static_components.iterator();
while( it.hasNext())
{
 ComponentEntry cet = (ComponentEntry)it.next();
if (cet.atExactLocation(machine))
{
cet.setDead();
Log(TRACING, "Marking dead "+cet);}
}

it=dynamic_components.iterator();
while( it.hasNext())
{
 ComponentEntry cet = (ComponentEntry)it.next();
if (cet.atExactLocation(machine))
{
it.remove();
Log(TRACING, "Removing "+cet);}
}

checkPendingConnections();}
 protected Port findMachinePort ( String yeah) 
{
synchronized (controller ) {
return controller.findPortWithTargetType(yeah);}
}
 protected void disconnect ( Port p) 
{
Log(CONNECTIONS, "Disconnect of "+p+" -> removing machine "+p.getInformation());
removeMachine(p.getInformation());
p.setInformation("---");}
 protected String getComponentPort ( String p) 
{
 String res;
res=p.substring(p.indexOf("/")+1);
Log(INTERNALS, "getComponentPort("+p+") = "+res);
return res;}
 protected String getComponentName ( String p) 
{
 String res;
res=p.substring(0, p.indexOf("/"));
Log(INTERNALS, "getComponentName("+p+") = "+res);
return res;}
 protected ComponentEntry getComponent ( String instance) 
{
 ComponentEntry result;
result=getComponent(static_components, instance);
if (result==null)
result=getComponent(dynamic_components, instance);
return result;}
 protected ComponentEntry getComponent ( List components,  String instance) 
{
 Iterator cit = components.iterator();
while( cit.hasNext())
{
 ComponentEntry cet = (ComponentEntry)cit.next();
if (cet.isName(instance))
return cet;}

return null;}
 protected void addPendingConnection ( List connections,  String a,  String b) 
{
 ConnectionEntry entry;
 ComponentEntry c1;
 ComponentEntry c2;
 String p1;
 String p2;
c1=getComponent(getComponentName(a));
c2=getComponent(getComponentName(b));
p1=getComponentPort(a);
p2=getComponentPort(b);
if (c1==null)
Fatal("controller: No component "+a+" defined in config file!");
if (c2==null)
Fatal("controller: No component "+b+" defined in config file!");
entry=new ConnectionEntry (c1, c2, p1, p2);
connections.add(entry);}
 protected void checkPendingConnections () 
{
checkPendingConnections("", static_connections);
checkPendingConnections("dynamically ", dynamic_connections);
 Iterator cit = dynamic_connections.iterator();
while( cit.hasNext())
{
 ConnectionEntry connection = (ConnectionEntry)cit.next();
if (connection.created&&connection.ready())
cit.remove();}
}
 protected void checkPendingConnections ( String prefix,  List connections) 
{
 Iterator cit = connections.iterator();
Log(INTERNALS, "Checking pending connections !!!");
while( cit.hasNext())
{
 ConnectionEntry connection = (ConnectionEntry)cit.next();
if (connection.created&&!connection.ready())
{
Log(STANDARD, "Removing connection "+connection.id1()+" - "+connection.id2());
connection.created=false;}

if (!connection.created&&connection.ready())
{
Log(STANDARD, prefix+"linking "+connection.id1()+" - "+connection.id2());
if ((location==null)||(connection.c1.atLocation(location)&&connection.c2.atLocation(location)))
{
Log(INTERNALS, "local creation done");
createConnection(connection.id1(), connection.id2());
connection.created=true;
continue;}

if (connection.c1.atLocation(connection.c2.location))
{
if (isMaster&&connections==dynamic_connections)
{
Log(INTERNALS, "remote local creation request send through");
 ComponentEntry c1 = connection.c1;
 ComponentEntry c2 = connection.c2;
if (c1.atUnknownLocation())
{
 ComponentEntry tmp = c1;
c1=c2;
c2=tmp;}

 Message inmessage = new Message ();
 Message outmessage = inmessage.copy();
{ outmessage.putField("Invoke","InstantiateConnection");
outmessage.putField("Id1",connection.id1());
outmessage.putField("Id2",connection.id2());
(findMachinePort(c1.location)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;
connection.created=true;}

continue;}

if (!isMaster)
continue;
 Message inmessage = new Message ();
 Message outmessage = inmessage.copy();
 ComponentEntry c1 = connection.c1;
 ComponentEntry c2 = connection.c2;
if (!c1.atLocation(location))
{
{ outmessage.putField("Invoke","SetupConnection");
outmessage.putField("Local",connection.id1());
outmessage.putField("Remote",connection.id2());
outmessage.putField("RemoteAddr",findMachineAddr(c2.location));
(findMachinePort(c1.location)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}

else {
{ outmessage.putField("Invoke","SetupConnection");
outmessage.putField("Local",connection.id2());
outmessage.putField("Remote",connection.id1());
outmessage.putField("RemoteAddr",findMachineAddr(c1.location));
(findMachinePort(c2.location)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}

connection.created=true;}
}
}
 protected String findMachineAddr ( String m) 
{
return (String)machines.get(m);}
 public synchronized void  SetupConnection(Port port, Message inmessage, Message outmessage) 
{
setupOutgoingConnection(((String)inmessage.getField("Local")), ((String)inmessage.getField("Remote")), ((String)inmessage.getField("RemoteAddr")));}
 public synchronized void  ComponentCreated(Port port, Message inmessage, Message outmessage) 
{
 String instance = ((String)inmessage.getField("Instance"));
Log(TRACING, instance+" has been created");
 ComponentEntry cet;
cet=getComponent(instance);
if (cet!=null)
{
cet.setReady();
checkPendingConnections();}

if (!isMaster)
{ outmessage.putField("Invoke","ComponentCreated");
outmessage.putField("BluePrint",(inmessage.getField("BluePrint")));
outmessage.putField("Instance",(inmessage.getField("Instance")));
(masterport).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  IntantiateComponent(Port port, Message inmessage, Message outmessage) 
{
if (isMaster)
Fatal("controller: InstantiateComponent message received ???");
if (port!=masterport)
Fatal("controller: InstantiateComponent not called from master");
 String blueprint = ((String)inmessage.getField("BluePrint"));
 String instance = ((String)inmessage.getField("Instance"));
 ComponentEntry cet = getComponent(instance);
Log(STANDARD, "creating "+blueprint);
if (cet==null)
addPendingComponent(dynamic_components, blueprint, instance, true);
{ outmessage.putField("Invoke","Init");
(createComponent(blueprint, instance)).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
 public synchronized void  MachineConnected(Port port, Message inmessage, Message outmessage) 
{
 String machine;
machine=((String)inmessage.getField("Machine"));
port.setInformation(machine);
Log(TRACING, "Machine "+machine+" connected");
machines.put(machine, ((String)inmessage.getField("Address")));
checkPendingComponents();}
 public synchronized void  Init(Port port, Message inmessage, Message outmessage) 
{
try 
{
if (name.compareTo("Controller")!=0)
Fatal("Controller should be called 'Controller'");
 String argument = ((String)inmessage.getField("Argument"));
 String filename;
if (argument==null)
{
filename="controller.ini";
location=null;}

else {
 int posat = argument.indexOf("@");
if (posat==-1)
{
filename=argument;
location=null;}

else {
filename=argument.substring(0, posat);
location=argument.substring(posat+1);}
}

Log(STANDARD, "reading "+filename);
if (location!=null)
Log(STANDARD, "this location is '"+location+"'");
 ComponentEntry cet;
cet=new ComponentEntry ("Controller", "--controller-blueprint--", null);
cet.setReady();
static_components.add(cet);
 FileInputStream fis = new FileInputStream (filename);
 InputStreamReader isr = new InputStreamReader (fis);
 BufferedReader bis = new BufferedReader (isr);
 String line = bis.readLine();
while( line!=null)
{
parseLine(line, inmessage);
line=bis.readLine();}

fis.close();
if (location==null||master.compareTo(location)==0)
{
Log(TRACING, "This controller seems to be the master controller");
isMaster=true;}

checkPendingComponents();
if (location!=null)
{
setupListening();
machines.put(location, connectionAcceptor.retrieveAddr());}

if (!isMaster)
{
Log(TRACING, "This controller seems to be a slave controller");
setupLinkToMaster();
{ outmessage.putField("Invoke","MachineConnected");
outmessage.putField("Machine",location);
outmessage.putField("Address",connectionAcceptor.retrieveAddr());
(masterport).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
}
catch ( FileNotFoundException e)
{
Log(STANDARD, "could not find file");}
catch ( IOException e)
{
Log(STANDARD, "an IOException occured");}
}
 public synchronized void  CreateComponent(Port port, Message inmessage, Message outmessage) 
{
 String instance = ((String)inmessage.getField("Instance"));
if (instance.indexOf(':')==-1&&location!=null)
instance=location+":"+instance;
 String blueprint = ((String)inmessage.getField("BluePrint"));
if (isMaster)
{
Log(DYNAMIC, "creation request "+instance);
Log(TRACING, "  blueprint = "+blueprint);
addPendingComponent(dynamic_components, blueprint, instance, false);
checkPendingComponents();}

else {
Log(DYNAMIC, "requesting creation "+instance);
Log(TRACING, "  blueprint = "+blueprint);
{ outmessage.putField("Invoke","CreateComponent");
outmessage.putField("BluePrint",blueprint);
outmessage.putField("Instance",instance);
(masterport).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
}
 public synchronized void  InstantiateConnection(Port port, Message inmessage, Message outmessage) 
{
 String id1 = ((String)inmessage.getField("Id1"));
 String id2 = ((String)inmessage.getField("Id2"));
addPendingConnection(dynamic_connections, id1, id2);
Log(INTERNALS, "instantiating connection "+id1+" - "+id2);
checkPendingConnections();}
 public synchronized void  CreateConnection(Port port, Message inmessage, Message outmessage) 
{
 String id1 = ((String)inmessage.getField("Id1"));
 String id2 = ((String)inmessage.getField("Id2"));
if (id1.indexOf(':')==-1&&location!=null)
id1=location+":"+id1;
if (id2.indexOf(':')==-1&&location!=null)
id2=location+":"+id2;
if (isMaster)
{
Log(DYNAMIC, "connection request "+id1+" - "+id2);
addPendingConnection(dynamic_connections, id1, id2);
checkPendingConnections();}

else {
Log(DYNAMIC, "requesting connection "+id1+" - "+id2);
{ outmessage.putField("Invoke","CreateConnection");
outmessage.putField("Id1",id1);
outmessage.putField("Id2",id2);
(masterport).sendMessage(outmessage);
outmessage=new Message(inmessage);}
;}
}
 }
;