" " " " " " " " " " " " " " " " " " " " " " " " " " " " "
"
" Dit is een syntaxfile voor VIM. Plaats dit bestand in
" ~/.vim/syntax/component.vim en VIM zal de syntax v/e 
" .component-bestand verstaan!
"
" MR 04/02
"
" " " " " " " " " " " " " " " " " " " " " " " " " " " " "




" Quit when a syntax file was already loaded
if !exists("main_syntax")
  if version < 600
    syntax clear
  elseif exists("b:current_syntax")
    finish
  endif
  " we define it here so that included files can test for it
  let main_syntax='component'
endif

" don't use standard HiLink, it will not work with included syntax files
if version < 508
  command! -nargs=+ ComponentHiLink hi link <args>
else
  command! -nargs=+ ComponentHiLink hi def link <args>
endif

" some characters that cannot be in a component program (outside a string)
syn match componentError "[\\@`]"
syn match componentError "<<<\|=>\|<>\|||=\|&&=\|[^-]->\|\*\/"

" use separate name so that it can be deleted in componentcc.vim
syn match componentError2 "#\|"
ComponentHiLink componentError2 componentError



" keyword definitions
syn keyword componentExternal        import native package
syn keyword componentError           goto const
syn keyword componentConditional     if else switch
syn keyword componentRepeat          while for do
syn keyword componentBoolean         true false
syn keyword componentConstant        null
syn keyword componentTypedef         this super
syn keyword componentOperator        new instanceof port multiport message active
syn keyword componentType            boolean char byte short int long float double
syn keyword componentType            void
syn keyword componentStatement       return
syn keyword componentStorageClass    static synchronized transient volatile final strictfp serializable
syn keyword componentExceptions      throw try catch finally
syn keyword componentAssert          assert
syn keyword componentMethodDecl      synchronized throws
syn keyword componentClassDecl       extends implements interface
" to differentiate the keyword class from MyClass.class we use a match here
syn match   componentTypedef         "\.\s*\<class\>"ms=s+1
syn match   componentClassDecl       "^class\>" 
syn match   componentClassDecl       "[^.]\s*\<class\>"ms=s+1
syn keyword componentBranch          break continue nextgroup=componentUserLabelRef skipwhite
syn match   componentUserLabelRef    "\k\+" contained
syn keyword componentScopeDecl       public protected private abstract

if exists("component_highlight_component_lang_ids") || exists("component_highlight_component_lang") || exists("component_highlight_all")
  " component.lang.*
  syn match componentLangClass "\<System\>"
  syn keyword componentLangClass  Cloneable Comparable Runnable Boolean Byte Class
  syn keyword componentLangClass  Character CharSequence ClassLoader Compiler Double Float
  syn keyword componentLangClass  Integer InheritableThreadLocal Long Math Number Object Package Process
  syn keyword componentLangClass  Runtime RuntimePermission InheritableThreadLocal
  syn keyword componentLangClass  SecurityManager Short String StrictMath StackTraceElement
  syn keyword componentLangClass  StringBuffer Thread ThreadGroup
  syn keyword componentLangClass  ThreadLocal Throwable Void ArithmeticException
  syn keyword componentLangClass  ArrayIndexOutOfBoundsException AssertionError
  syn keyword componentLangClass  ArrayStoreException ClassCastException
  syn keyword componentLangClass  ClassNotFoundException
  syn keyword componentLangClass  CloneNotSupportedException Exception
  syn keyword componentLangClass  IllegalAccessException
  syn keyword componentLangClass  IllegalArgumentException
  syn keyword componentLangClass  IllegalMonitorStateException
  syn keyword componentLangClass  IllegalStateException
  syn keyword componentLangClass  IllegalThreadStateException
  syn keyword componentLangClass  IndexOutOfBoundsException
  syn keyword componentLangClass  InstantiationException InterruptedException
  syn keyword componentLangClass  NegativeArraySizeException NoSuchFieldException
  syn keyword componentLangClass  NoSuchMethodException NullPointerException
  syn keyword componentLangClass  NumberFormatException RuntimeException
  syn keyword componentLangClass  SecurityException StringIndexOutOfBoundsException
  syn keyword componentLangClass  UnsupportedOperationException
  syn keyword componentLangClass  AbstractMethodError ClassCircularityError
  syn keyword componentLangClass  ClassFormatError Error ExceptionInInitializerError
  syn keyword componentLangClass  IllegalAccessError InstantiationError
  syn keyword componentLangClass  IncompatibleClassChangeError InternalError
  syn keyword componentLangClass  LinkageError NoClassDefFoundError
  syn keyword componentLangClass  NoSuchFieldError NoSuchMethodError
  syn keyword componentLangClass  OutOfMemoryError StackOverflowError
  syn keyword componentLangClass  ThreadDeath UnknownError UnsatisfiedLinkError
  syn keyword componentLangClass  UnsupportedClassVersionError VerifyError
  syn keyword componentLangClass  VirtualMachineError
  syn keyword componentLangObject clone equals finalize getClass hashCode
  syn keyword componentLangObject notify notifyAll toString wait
  ComponentHiLink componentLangClass                   componentConstant
  ComponentHiLink componentLangObject                  componentConstant
  syn cluster componentTop add=componentLangObject,componentLangClass
  syn cluster componentClasses add=componentLangClass
endif

if exists("component_space_errors")
  if !exists("component_no_trail_space_error")
    syn match   componentSpaceError  "\s\+$"
  endif
  if !exists("component_no_tab_space_error")
    syn match   componentSpaceError  " \+\t"me=e-1
  endif
endif

syn region  componentLabelRegion     transparent matchgroup=componentLabel start="\<case\>" matchgroup=NONE end=":" contains=componentNumber,componentCharacter
syn match   componentUserLabel       "^\s*[_$a-zA-Z][_$a-zA-Z0-9_]*\s*:"he=e-1 contains=componentLabel
syn keyword componentLabel           default

if !exists("component_allow_cpp_keywords")
  syn keyword componentError auto delete enum extern friend inline redeclared
  syn keyword componentError register signed sizeof struct template typedef union
  syn keyword componentError unsigned operator
endif

" The following cluster contains all component groups except the contained ones
syn cluster componentTop add=componentExternal,componentError,componentError,componentBranch,componentLabelRegion,componentLabel,componentConditional,componentRepeat,componentBoolean,componentConstant,componentTypedef,componentOperator,componentType,componentType,componentStatement,componentStorageClass,componentAssert,componentExceptions,componentMethodDecl,componentClassDecl,componentClassDecl,componentClassDecl,componentScopeDecl,componentError,componentError2,componentUserLabel,componentLangObject


" Comments
syn keyword componentTodo             contained TODO FIXME XXX
if exists("component_comment_strings")
syn region  componentCommentString    contained start=+"+ end=+"+ end=+$+ end=+\*/+me=s-1,he=s-1 contains=componentSpecial,componentCommentStar,componentSpecialChar,@Spell
syn region  componentComment2String   contained start=+"+  end=+$\|"+  contains=componentSpecial,componentSpecialChar,@Spell
syn match   componentCommentCharacter contained "'\\[^']\{1,6\}'" contains=componentSpecialChar
syn match   componentCommentCharacter contained "'\\''" contains=componentSpecialChar
syn match   componentCommentCharacter contained "'[^\\]'"
  syn cluster componentCommentSpecial add=componentCommentString,componentCommentCharacter,componentNumber
  syn cluster componentCommentSpecial2 add=componentComment2String,componentCommentCharacter,componentNumber
endif
syn region  componentComment          start="/\*"  end="\*/" contains=@componentCommentSpecial,componentTodo,@Spell
syn match   componentCommentStar      contained "^\s*\*[^/]"me=e-1
syn match   componentCommentStar      contained "^\s*\*$"
syn match   componentLineComment      "//.*" contains=@componentCommentSpecial2,componentTodo,@Spell
ComponentHiLink componentCommentString componentString
ComponentHiLink componentComment2String componentString
ComponentHiLink componentCommentCharacter componentCharacter

syn cluster componentTop add=componentComment,componentLineComment

" match the special comment /**/
syn match   componentComment          "/\*\*/"

" Strings and constants
syn match   componentSpecialError     contained "\\."
syn match   componentSpecialCharError contained "[^']"
syn match   componentSpecialChar      contained "\\\([4-9]\d\|[0-3]\d\d\|[\"\\'ntbrf]\|u\x\{4\}\)"
syn region  componentString          start=+"+ end=+"+ end=+$+ contains=componentSpecialChar,componentSpecialError,@Spell
" next line disabled, it can cause a crash for a long line
"syn match   componentStringError      +"\([^"\\]\|\\.\)*$+
syn match   componentCharacter        "'[^']*'" contains=componentSpecialChar,componentSpecialCharError
syn match   componentCharacter        "'\\''" contains=componentSpecialChar
syn match   componentCharacter        "'[^\\]'"
syn match   componentNumber           "\<\(0[0-7]*\|0[xX]\x\+\|\d\+\)[lL]\=\>"
syn match   componentNumber           "\(\<\d\+\.\d*\|\.\d\+\)\([eE][-+]\=\d\+\)\=[fFdD]\="
syn match   componentNumber           "\<\d\+[eE][-+]\=\d\+[fFdD]\=\>"
syn match   componentNumber           "\<\d\+\([eE][-+]\=\d\+\)\=[fFdD]\>"
syn match   componentNumber           "\.\."

" unicode characters
syn match   componentSpecial "\\u\d\{4\}"

syn cluster componentTop add=componentString,componentCharacter,componentNumber,componentSpecial,componentStringError

if exists("component_highlight_functions")
  if component_highlight_functions == "indent"
    syn match  componentFuncDef "^\(\t\| \{8\}\)[_$a-zA-Z][_$a-zA-Z0-9_. \[\]]*([^-+*/()]*)" contains=componentScopeDecl,componentType,componentStorageClass,@componentClasses
    syn region componentFuncDef start=+^\(\t\| \{8\}\)[$_a-zA-Z][$_a-zA-Z0-9_. \[\]]*([^-+*/()]*,\s*+ end=+)+ contains=componentScopeDecl,componentType,componentStorageClass,@componentClasses
    syn match  componentFuncDef "^  [$_a-zA-Z][$_a-zA-Z0-9_. \[\]]*([^-+*/()]*)" contains=componentScopeDecl,componentType,componentStorageClass,@componentClasses
    syn region componentFuncDef start=+^  [$_a-zA-Z][$_a-zA-Z0-9_. \[\]]*([^-+*/()]*,\s*+ end=+)+ contains=componentScopeDecl,componentType,componentStorageClass,@componentClasses
  else
    " This line catches method declarations at any indentation>0, but it assumes
    " two things:
    "   1. class names are always capitalized (ie: Button)
    "   2. method names are never capitalized (except constructors, of course)
    syn region componentFuncDef start=+^\s\+\(\(public\|protected\|private\|static\|abstract\|final\|native\|synchronized\)\s\+\)*\(\(void\|boolean\|char\|byte\|short\|int\|long\|float\|double\|\([A-Za-z_][A-Za-z0-9_$]*\.\)*[A-Z][A-Za-z0-9_$]*\)\(\[\]\)*\s\+[a-z][A-Za-z0-9_$]*\|[A-Z][A-Za-z0-9_$]*\)\s*(+ end=+)+ contains=componentScopeDecl,componentType,componentStorageClass,componentComment,componentLineComment,@componentClasses
  endif
  syn match  componentBraces  "[{}]"
  syn cluster componentTop add=componentFuncDef,componentBraces
endif

if exists("component_highlight_debug")

  " Strings and constants
  syn match   componentDebugSpecial          contained "\\\d\d\d\|\\."
  syn region  componentDebugString           contained start=+"+  end=+"+  contains=componentDebugSpecial
  syn match   componentDebugStringError      +"\([^"\\]\|\\.\)*$+
  syn match   componentDebugCharacter        contained "'[^\\]'"
  syn match   componentDebugSpecialCharacter contained "'\\.'"
  syn match   componentDebugSpecialCharacter contained "'\\''"
  syn match   componentDebugNumber           contained "\<\(0[0-7]*\|0[xX]\x\+\|\d\+\)[lL]\=\>"
  syn match   componentDebugNumber           contained "\(\<\d\+\.\d*\|\.\d\+\)\([eE][-+]\=\d\+\)\=[fFdD]\="
  syn match   componentDebugNumber           contained "\<\d\+[eE][-+]\=\d\+[fFdD]\=\>"
  syn match   componentDebugNumber           contained "\<\d\+\([eE][-+]\=\d\+\)\=[fFdD]\>"
  syn keyword componentDebugBoolean          contained true false
  syn keyword componentDebugType             contained null this super
  syn region componentDebugParen  start=+(+ end=+)+ contained contains=componentDebug.*,componentDebugParen

  " to make this work you must define the highlighting for these groups
  syn match componentDebug "System\.\(out\|err\)\.print\(ln\)*\s*("me=e-1 contains=componentDebug.* nextgroup=componentDebugParen
  syn match componentDebug "[A-Za-z][a-zA-Z0-9_]*\.printStackTrace\s*("me=e-1 contains=componentDebug.* nextgroup=componentDebugParen
  syn match componentDebug "trace[SL]\=\s*("me=e-1 contains=componentDebug.* nextgroup=componentDebugParen

  syn cluster componentTop add=componentDebug

  if version >= 508 || !exists("did_c_syn_inits")
    ComponentHiLink componentDebug                 Debug
    ComponentHiLink componentDebugString           DebugString
    ComponentHiLink componentDebugStringError      componentError
    ComponentHiLink componentDebugType             DebugType
    ComponentHiLink componentDebugBoolean          DebugBoolean
    ComponentHiLink componentDebugNumber           Debug
    ComponentHiLink componentDebugSpecial          DebugSpecial
    ComponentHiLink componentDebugSpecialCharacter DebugSpecial
    ComponentHiLink componentDebugCharacter        DebugString
    ComponentHiLink componentDebugParen            Debug

    ComponentHiLink DebugString               String
    ComponentHiLink DebugSpecial              Special
    ComponentHiLink DebugBoolean              Boolean
    ComponentHiLink DebugType                 Type
  endif
endif

if exists("component_mark_braces_in_parens_as_errors")
  syn match componentInParen          contained "[{}]"
  ComponentHiLink componentInParen        componentError
  syn cluster componentTop add=componentInParen
endif

" catch errors caused by wrong parenthesis
syn region  componentParen            transparent start="(" end=")" contains=@componentTop,componentParen
syn match   componentParenError       ")"
ComponentHiLink componentParenError       componentError

if !exists("component_minlines")
  let component_minlines = 10
endif
exec "syn sync ccomment componentComment minlines=" . component_minlines

" The default highlighting.
if version >= 508 || !exists("did_component_syn_inits")
  if version < 508
    let did_component_syn_inits = 1
  endif
  ComponentHiLink componentFuncDef		Function
  ComponentHiLink componentBraces			Function
  ComponentHiLink componentBranch			Conditional
  ComponentHiLink componentUserLabelRef		componentUserLabel
  ComponentHiLink componentLabel			Label
  ComponentHiLink componentUserLabel		Label
  ComponentHiLink componentConditional		Conditional
  ComponentHiLink componentRepeat			Repeat
  ComponentHiLink componentExceptions		Exception
  ComponentHiLink componentAssert			Statement
  ComponentHiLink componentStorageClass		StorageClass
  ComponentHiLink componentMethodDecl		componentStorageClass
  ComponentHiLink componentClassDecl		componentStorageClass
  ComponentHiLink componentScopeDecl		componentStorageClass
  ComponentHiLink componentBoolean		Boolean
  ComponentHiLink componentSpecial		Special
  ComponentHiLink componentSpecialError		Error
  ComponentHiLink componentSpecialCharError	Error
  ComponentHiLink componentString			String
  ComponentHiLink componentCharacter		Character
  ComponentHiLink componentSpecialChar		SpecialChar
  ComponentHiLink componentNumber			Number
  ComponentHiLink componentError			Error
  ComponentHiLink componentStringError		Error
  ComponentHiLink componentStatement		Statement
  ComponentHiLink componentOperator		Operator
  ComponentHiLink componentComment		Comment
  ComponentHiLink componentDocComment		Comment
  ComponentHiLink componentLineComment		Comment
  ComponentHiLink componentConstant		Constant
  ComponentHiLink componentTypedef		Typedef
  ComponentHiLink componentTodo			Todo

  ComponentHiLink componentCommentTitle		SpecialComment
  ComponentHiLink componentDocTags		Special
  ComponentHiLink componentDocParam		Function
  ComponentHiLink componentCommentStar		componentComment

  ComponentHiLink componentType			Type
  ComponentHiLink componentExternal		Include

  ComponentHiLink htmlComment		Special
  ComponentHiLink htmlCommentPart		Special
  ComponentHiLink componentSpaceError		Error
endif

delcommand ComponentHiLink

let b:current_syntax = "component"

if main_syntax == 'component'
  unlet main_syntax
endif

let b:spell_options="contained"

" vim: ts=8
