package testcases.scss.motiondetection;

public class SensitivityMDCommand extends MDCommand{

    public SensitivityMDCommand(CameraMD cMD){
	super(cMD);
    }

    public void execute(Object o){
	try{
	    super.execute(o);
	    String s = (String)o;
	    System.out.println("MD: Sensitivity = "+s);
	    int sValue;
	    if(s.equals("detect_no_change") || s.equals("No Changes")){
		sValue = CameraMD.DETECT_NO_CHANGE;
	    }else if(s.equals("detect_large_changes") || s.equals("Large Changes")){
		sValue = CameraMD.DETECT_LARGE_CHANGES;
	    }else if(s.equals("detect_changes") || s.equals("Changes")){
		sValue = CameraMD.DETECT_CHANGES;
	    }else if(s.equals("detect_small_changes") || s.equals("Small Changes")){
		sValue = CameraMD.DETECT_SMALL_CHANGES;
	    }else { // DETECT_EVERY_CHANGE
		sValue = CameraMD.DETECT_EVERY_CHANGE;
	    }
	    getCameraMD().getDetector().setSensitivity(new Sensitivity(sValue));
	}catch(ClassCastException cce){
	    // the specs weren't followed... just return
	    return;
	}
    }

    public Object getValue(){
	if(getCameraMD().getDetector().getSensitivity().getValue() == CameraMD.DETECT_NO_CHANGE){
	    return new String("detect_no_change");
	}else if(getCameraMD().getDetector().getSensitivity().getValue() == CameraMD.DETECT_LARGE_CHANGES){
	    return new String("detect_large_changes");
	}else if(getCameraMD().getDetector().getSensitivity().getValue() == CameraMD.DETECT_CHANGES){
	    return new String("detect_changes");
	}else if(getCameraMD().getDetector().getSensitivity().getValue() == CameraMD.DETECT_SMALL_CHANGES){
	    return new String("detect_small_changes");
	}else {  // DETECT_EVERY_CHANGE
	    return new String("detect_every_change");
	}
    }

    public String toString(){
	return "Sensitivity Command";
    }

}
