package testcases.scss.motiondetection.test;

import testcases.scss.motiondetection.*;	
import thesis.application.imageclient.*;

public class MDTestMain{

    private static final int $defaultPort = 5000;

    public static void main(String[] args){
	if (args.length < 1) syntaxError();
	int colon = args[0].indexOf (":");
	String host = (colon > -1) ? args[0].substring(0, colon) : args[0];
	int port = ((colon > -1) && (colon < args[0].length () - 1)) ? Integer.parseInt(args[0].substring (colon + 1)) : $defaultPort;
	if (host == null) syntaxError();

	ImageClient client = new ImageClient(host, port);
	CameraMDTest ct = new CameraMDTest();
	client.addImageListener(ct);
    }

    /**
     *	Print a syntax error
     */
    private static void syntaxError() {
	System.out.println("Syntax: ImageClient <hostname>[:<port>]");
	System.exit(1);
    }
}
