package testcases.scss.motiondetection.testcomponent;

import testcases.scss.motiondetection.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.awt.*;
import java.awt.event.*;

public class MDControlPanel extends JFrame{
    
    public MDControlPanel(MDVisualizer visualizer){
	super("Motion Detection Controller");

	$visualizer = visualizer;

	$mainPanel = new JPanel(new GridLayout(2,1));
	$videoLayeredPane = new JLayeredPane();
//	$videoLayeredPane.setLayout(new GridLayout(1,1));
	$videoPanel = new JPanel(new BorderLayout());
	$hotspotCanvas = new HotspotCanvas();
	$controlPanel = new JPanel(new BorderLayout());
	$mainPanel.setBackground(Color.green);

	$videoCanvas = new VideoCanvas();
	$videoLayeredPane.setPreferredSize(new Dimension(WIDTH, HEIGHT));
	$videoPanel.setPreferredSize(new Dimension(WIDTH, HEIGHT));
	$videoCanvas.setPreferredSize(new Dimension(WIDTH, HEIGHT));
	$hotspotCanvas.setPreferredSize(new Dimension(WIDTH, HEIGHT));	
    
	$frameratePanel = new JPanel();
	Border etchedBorder = BorderFactory.createEtchedBorder();
	$frameratePanel.setBorder(BorderFactory.createTitledBorder(etchedBorder, "Framerate"));
	$framerateSlider = new JSlider(JSlider.HORIZONTAL, 1, 10, 2);
	$framerateSlider.setMajorTickSpacing(1);
	$framerateSlider.setMinorTickSpacing(1);
	$framerateSlider.setPaintTicks(true);
	$framerateSlider.setPaintLabels(true);
	$framerateSlider.setPaintTrack(true);
	$frameratePanel.add($framerateSlider);

	$sensitivityPanel = new JPanel(new GridLayout(0, 1));
	etchedBorder = BorderFactory.createEtchedBorder();
	$sensitivityPanel.setBorder(BorderFactory.createTitledBorder(etchedBorder, "Sensitivity"));
	$sensitivityGroup = new ButtonGroup();
	$noChange  = new JRadioButton("No Changes", false);
	$largeChanges  = new JRadioButton("Large Changes", false);
	$changes = new JRadioButton("Changes", true);
	$smallChanges  = new JRadioButton("Small Changes", false);
	$everyChange = new JRadioButton("Every Change", false);
	$sensitivityGroup.add($noChange);
	$sensitivityGroup.add($largeChanges);
	$sensitivityGroup.add($changes);
	$sensitivityGroup.add($smallChanges);
	$sensitivityGroup.add($everyChange);
	$sensitivityPanel.add($noChange);
	$sensitivityPanel.add($largeChanges);
	$sensitivityPanel.add($changes);
	$sensitivityPanel.add($smallChanges);
	$sensitivityPanel.add($everyChange);

	$settingsPanel = new JPanel(new GridLayout(0, 1));
	etchedBorder = BorderFactory.createEtchedBorder();
	$settingsPanel.setBorder(BorderFactory.createTitledBorder(etchedBorder, "Settings"));
	$evolvable = new JCheckBox("Evolvable", true);
	$switching = new JCheckBox("Switching", true);
	$alarmLogging = new JCheckBox("Alarm Logging", true);
	$settingsPanel.add($evolvable);
	$settingsPanel.add($switching);
	$settingsPanel.add($alarmLogging);
 
	$hotspotPanel = new JPanel(new GridLayout(2, 1));
        etchedBorder = BorderFactory.createEtchedBorder();
        $hotspotPanel.setBorder(BorderFactory.createTitledBorder(etchedBorder, "Hotspot"));
	$clearHotspotButton = new JButton("Clear");
	$setHotspotButton = new JButton("Set");
	$hotspotPanel.add($clearHotspotButton);
	$hotspotPanel.add($setHotspotButton);

        $timingPanel = new JPanel(new GridLayout(1, 5));
        etchedBorder = BorderFactory.createEtchedBorder();
        $timingPanel.setBorder(BorderFactory.createTitledBorder(etchedBorder, "Timing"));
	$waitEnable = new JLabel("  Wait Enable ");
	$waitDisable = new JLabel("  Wait Disable ");
	$enable = new JTextField(3);
	$disable = new JTextField(3);
	$waitSetButton = new JButton("Set");
        $timingPanel.add($waitEnable);
	$timingPanel.add($enable);
	$timingPanel.add($waitDisable);
	$timingPanel.add($disable);
	$timingPanel.add($waitSetButton);

	$controlPanel.add($frameratePanel, BorderLayout.NORTH);
	$controlPanel.add($sensitivityPanel, BorderLayout.WEST);
	$controlPanel.add($settingsPanel, BorderLayout.CENTER);
	$controlPanel.add($hotspotPanel, BorderLayout.EAST);
	$controlPanel.add($timingPanel, BorderLayout.SOUTH);

	$videoPanel.add($videoCanvas, BorderLayout.CENTER);
	$videoPanel.setBounds(75, 25, WIDTH, HEIGHT);
	$hotspotCanvas.setBounds(75, 25, WIDTH, HEIGHT);
	$videoLayeredPane.add($videoPanel, new Integer(2));
	$videoLayeredPane.add($hotspotCanvas, new Integer(5));
//	JButton b = new JButton("Push me");
//	b.setBounds(80, 20, 60, 80);
//	b.setOpaque(true);
//	$videoLayeredPane.add(b, new Integer(5));
	$mainPanel.add($videoLayeredPane);
	$mainPanel.add($controlPanel);
	getContentPane().add($mainPanel);

	pack();
	setVisible(true);

	/*
	 * Adding action (listeners):
	 */	
	$framerateSlider.addChangeListener(new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
		    JSlider source = (JSlider)e.getSource();
		    if (!source.getValueIsAdjusting()) {
			Object fps = new Integer((int)source.getValue());
			String s = new String("framerate");
			$visualizer.set(s, fps);
			$mainPanel.repaint();
		    }
		}
	    });

	$noChange.setAction(new AbstractAction(){
		public void actionPerformed(ActionEvent e){
		    Object o = new String("detect_no_change");
		    String s = new String("sensitivity");
		    $visualizer.set(s, o);
		    $mainPanel.repaint();
		}
	    });

	$largeChanges.setAction(new AbstractAction(){
		public void actionPerformed(ActionEvent e){
		    Object o = new String("detect_large_changes");
		    String s = new String("sensitivity");
		    $visualizer.set(s, o);
		    $mainPanel.repaint();
		}
	    });

	$changes.setAction(new AbstractAction(){
		public void actionPerformed(ActionEvent e){
		    Object o = new String("Changes");
		    String s = new String("sensitivity");
		    $visualizer.set(s, o);
		    $mainPanel.repaint();
		}
	    });

	$smallChanges.setAction(new AbstractAction(){
		public void actionPerformed(ActionEvent e){
		    Object o = new String("Small Changes");
		    String s = new String("sensitivity");
		    $visualizer.set(s, o);
		    $mainPanel.repaint();
		}
	    });

	$everyChange.setAction(new AbstractAction(){
		public void actionPerformed(ActionEvent e){
		    Object o = new String("Every Change");
		    String s = new String("sensitivity");
		    $visualizer.set(s, o);
		    $mainPanel.repaint();
		}
	    });

	$noChange.setText("No Changes");
	$largeChanges.setText("Large Changes");
	$changes.setText("Changes");
	$smallChanges.setText("Small Changes");
	$everyChange.setText("Every Change");

	$setHotspotButton.setAction(new AbstractAction(){
		public void actionPerformed(ActionEvent e){
		    $hotspotDrawState = NO_CORNERS;
		}
	    });

	$clearHotspotButton.setAction(new AbstractAction(){
		public void actionPerformed(ActionEvent e){
		    $hotspotDrawState = NO_HOTSPOT;
		    $hotspotCanvas.setHotspot(null);
		    $hotspotCanvas.repaint();
		    Integer[] spot = new Integer[4];
		    spot[0] = new Integer(0);
		    spot[1] = new Integer(0);
		    spot[2] = new Integer(WIDTH-1);
		    spot[3] = new Integer(HEIGHT-1);
		    String s = new String("hotspot");
		    $visualizer.set(s, spot);
		}
	    });

	$setHotspotButton.setText("Set");
	$clearHotspotButton.setText("Clear");

	$videoPanel.addMouseMotionListener(new MouseMotionAdapter() {
		public void mouseDragged(MouseEvent e){
		    if($hotspotDrawState == NO_CORNERS){
			$hotspotCanvas.setHotspot(new Hotspot(e.getX(), e.getY(), 
							      e.getX()+1, e.getY()+1));
			$hotspotDrawState = ONE_CORNER;
			$hotspotCanvas.repaint();
		    }else if($hotspotDrawState == ONE_CORNER){
			$hotspotCanvas.setHotspot(new Hotspot($hotspotCanvas.getHotspot().getX(), 
							      $hotspotCanvas.getHotspot().getY(), 
							      e.getX()-$hotspotCanvas.getHotspot().getX(), 
							      e.getY()-$hotspotCanvas.getHotspot().getY()));
			$hotspotCanvas.repaint();
		    }
		}
		public void mouseMoved(MouseEvent e){
		    if($hotspotDrawState == ONE_CORNER){
			$hotspotDrawState = HOTSPOT;
			$hotspotCanvas.repaint();
			Integer[] spot = new Integer[4];
			spot[0] = new Integer($hotspotCanvas.getHotspot().getX());
			spot[1] = new Integer($hotspotCanvas.getHotspot().getY());
			spot[2] = new Integer($hotspotCanvas.getHotspot().getWidth());
			spot[3] = new Integer($hotspotCanvas.getHotspot().getHeight());
			String s = new String("hotspot");
			$visualizer.set(s, spot);
		     }
		}
	    });

	$evolvable.addItemListener(new ItemListener() {
		public void itemStateChanged(ItemEvent e) {
		    if(e.getStateChange() == ItemEvent.SELECTED){
			Object o = new String("evolvable");
			String s = new String("reference");
			$visualizer.set(s, o);
			$mainPanel.repaint();
		    }else{
			Object o = new String("static");
			String s = new String("reference");
			$visualizer.set(s, o);
			$mainPanel.repaint();
		    }
		}
	    });

	    /* setAction(new AbstractAction(){
	       public void actionPerformed(ActionEvent e){
	       Object o = new String("detect_no_change");
	       String s = new String("sensitivity");
	       $visualizer.set(s, o);
	       $mainPanel.repaint();
	       }
	       });
	    */

    }

    public void update(Graphics g){
	paint(g); 
    }
    
    public void setImage(Image image){
	$videoCanvas.setImage(image);
	pack();
    }

    public void detecting(boolean detecting){
	if(detecting){
	    $mainPanel.setBackground(Color.red);
//	    System.out.println("Start detecting");
	}else{
	    $mainPanel.setBackground(Color.green);
//	    System.out.println("Stop detecting");
	}
    }

    private MDVisualizer $visualizer;

    private JPanel $mainPanel;
    private JLayeredPane $videoLayeredPane;
    private JPanel $videoPanel;
    private HotspotCanvas $hotspotCanvas;
    private JPanel $controlPanel;
    private JPanel $frameratePanel;
    private JPanel $sensitivityPanel;
    private JPanel $settingsPanel;
    private JPanel $hotspotPanel;
    private JPanel $timingPanel;

    private VideoCanvas $videoCanvas;

    private JSlider $framerateSlider;

    private ButtonGroup $sensitivityGroup;
    private JRadioButton $noChange;
    private JRadioButton $largeChanges;
    private JRadioButton $changes;
    private JRadioButton $smallChanges;
    private JRadioButton $everyChange;

    private JCheckBox $evolvable;
    private JCheckBox $switching;
    private JCheckBox $alarmLogging;

    private JButton $setHotspotButton;
    private JButton $clearHotspotButton;
    private int $hotspotDrawState = NO_HOTSPOT;
    private final static int NO_HOTSPOT = 1;
    private final static int NO_CORNERS = 2;
    private final static int ONE_CORNER = 3;
    private final static int HOTSPOT = 4;

    private JLabel $waitEnable;
    private JTextField $enable;
    private JLabel $waitDisable;
    private JTextField $disable;
    private JButton $waitSetButton;

    private final static int WIDTH = 320;
    private final static int HEIGHT = 240;
}

