package testcases.scss.motiondetection.testcomponent;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import javax.swing.*; 

public class VideoCanvas extends JPanel {
	private Image image;
	private Dimension prefer; 

	public VideoCanvas(){
		super();
		image = null;
		prefer = null; 
	}

	public void setImage(Image image){
		this.image = image;

		int height = image.getHeight(null);
		int width  = image.getWidth(null);
		prefer = new Dimension(width, height); 
		repaint();
	}

 	public void repaint(Graphics g){
		paint(g); 
 	}

	public Dimension getPreferredSize(){
		return prefer; 
	}

	public void paint(Graphics g){
	    if(image!=null && prefer!=null){
		Dimension d = getSize();
		int dx = (int)(d.getWidth()-prefer.getWidth());
		int dy = (int)(d.getHeight()-prefer.getHeight());
		g.drawImage(image, dx/2, dy/2, this);
	    }
	}
}
