package testcases.scss.util;

import java.io.Serializable;

/**
 * Identifier object.
 *
 *  Generic identifier object for storing a camera ID or
 *  component ID.
 *
 * @author Miro Casanova
 * @author Dennis Wagelaar
 * @version 16 October 2002
 */

public class ID implements Serializable {

	////////////////////////////////////////////////////////////////////////
	// Attributes
	////////////////////////////////////////////////////////////////////////

	private String $id;

	////////////////////////////////////////////////////////////////////////
	// Constructors
	////////////////////////////////////////////////////////////////////////

	/**
	 * Constructs an ID.
	 * @author Miro Casanova
	 */
	public ID() {
	} //ID

	/**
	 * Constructs an ID.
	 * @author Miro Casanova
	 * @author Dennis Wagelaar
	 */
	public ID(String id)
	{
		this.$id  =  id;
	} //ID

	////////////////////////////////////////////////////////////////////////
	// Public methods
	////////////////////////////////////////////////////////////////////////

	/**
	 * Sets the ID.
	 * @param id The ID to set
	 * @author Miro Casanova
	 * @author Dennis Wagelaar
	 */
	public void setID(String id)
	{
		this.$id = id;
	} //setID

	/**
	 * Sets the ID.
	 * @return The ID
	 * @author Miro Casanova
	 * @author Dennis Wagelaar
	 */
	public String getID()
	{
		return this.$id;
	} //getID

} //class ID
