# SQL script for creating the tables within the
# storage database. Note that the "databaseUserCreation.sql"
# script must be executed before this script!
#
# Authors: Miro Casanova, Dennis Wagelaar
# Date:    14 October 2002

## Connect to DB

use storage;

## Tables creation

CREATE TABLE image (
	imageID			varchar(40) NOT NULL,
	cameraID		varchar(40) NOT NULL,
	time			datetime NOT NULL,
	millisec		int NOT NULL,
	path			varchar(255) NOT NULL,
	PRIMARY KEY (imageID),
	INDEX (imageID, cameraID, time)
);

CREATE TABLE event (
	eventID			varchar(40) NOT NULL,
	componentID		varchar(40) NOT NULL,
	time			datetime NOT NULL,
	millisec		int NOT NULL,
	message			varchar(255),
	PRIMARY KEY (eventID),
	INDEX (eventID, componentID, time)
);

CREATE TABLE alarm (
	alarmID			varchar(40) NOT NULL,
	cameraID		varchar(40) NOT NULL,
	time 			datetime NOT NULL,
	millisec		int NOT NULL,
	message			varchar(255),
	PRIMARY KEY (alarmID),
	INDEX (alarmID, cameraID, time)
);
