
// MR

#ifndef RGB
# ifndef RGBA
#   error You should define either RGB or RGBA
# endif
#endif

#ifdef RGB
unsigned char arrays[]={
	255,0, 255,0, 255,0, 255,0,   	// 0   <- %edx
	0,1, 0,0, 0,1, 0,0,   		// 8
	0,0, 0,1, 0,0, 0,1,    		//16
	128,0, 128,0, 128,0, 128,0,   	//24   = %mm5
};
#endif
#ifdef RGBA
unsigned char arraysA[]={
	255,0, 255,0, 255,0, 255,0,   	// 0   <- %edx
	0,1, 0,0, 0,1, 0,0,   		// 8
	0,0, 0,1, 0,0, 0,1,    		//16
	128,0, 128,0, 128,0, 128,0,   	//24   = %mm5
	0xFF,0,0,0,0xFF,0,0,0           //32
};
#endif

#ifdef RGB
int yuv422torgb (char *YUV, char *RGB_, int NumPixels) {
#endif
#ifdef RGBA
int yuv422torgba (char *YUV, char *RGB_, int NumPixels) {
#endif
	asm(
			"push %%ebx\n\t"
			"push %%ecx\n\t"

			"mov %1, %%eax\n\t"
			"mov %0, %%ebx\n\t"
			"mov %2, %%ecx\n\t"
			"mov %3, %%edx\n\t"


			"shr $2, %%ecx\n\t"
			"movq 24(%%edx), %%mm5\n\t"   // %mm5 = 80808080

			".align 16\n\t"
			".L99:\n\t"

			"movq (%%eax), %%mm0\n\t"
			"movq %%mm0, %%mm1\n\t"
			"movq %%mm0, %%mm2\n\t"

		//////// Y
			"psrlq $8, %%mm0\n\t"
			"pand (%%edx), %%mm0\n\t"

		//////// U
			"pmullw 8(%%edx), %%mm1\n\t"
			"psrlq $8, %%mm1\n\t"
			"movq %%mm1, %%mm7\n\t"			
			"psllq $16, %%mm7\n\t"
			"por %%mm7, %%mm1\n\t"

		//////// V
			"pmullw 16(%%edx), %%mm2\n\t"
			"psrlq $24, %%mm2\n\t"
			"movq %%mm2, %%mm7\n\t"			
			"psllq $16, %%mm7\n\t"
			"por %%mm7, %%mm2\n\t"

			// Situatie:
			// 	%%mm0 -> Y0Y0Y0Y0
			// 	%%mm1 -> U0U0U0U0
			// 	%%mm2 -> V0V0V0V0

		////////////////////////////////////////////////	
			

		/*	
		 *	R = Y + V
		 *	G = Y - V - V
		 *	B = Y + U
		 */

/*			
		/////// R = Y + V - 128
			"movq %%mm0, %%mm4\n\t"
			"paddd %%mm2, %%mm4\n\t"
			"psubusw %%mm5, %%mm4\n\t"
			"packuswb %%mm4, %%mm4\n\t"

		////// 	B = Y + U - 128
			"movq %%mm0, %%mm6\n\t"
			"paddd %%mm1, %%mm6\n\t"
			"psubusw %%mm5, %%mm6\n\t"
			"packuswb %%mm6, %%mm6\n\t"

		//////  G = Y - V - U + 256	
			// DIT MAG/KAN TOCH VEEL EENVOUDIGER???
			"paddd %%mm5, %%mm0\n\t"
			"paddd %%mm5, %%mm0\n\t"
			"psubusw %%mm1, %%mm0\n\t"
			"psubusw %%mm2, %%mm0\n\t"
			"packuswb %%mm0, %%mm0\n\t"
*/
		////////////////////////////////////////////////	


		/*	
		 *	R = Y + 0.75V
		 *	G = Y - 0.1875V - 0.28125V
		 *	B = Y + U
		 */
	
		/////// R = Y + V - 128 - V>>2 +128>>2
			"movq %%mm0, %%mm4\n\t"     // Y
			"paddd %%mm2, %%mm4\n\t"    // V
			"psubusw %%mm5, %%mm4\n\t"  // -128
			// +32
			"movq %%mm5, %%mm7\n\t"
			"psrld $2, %%mm7\n\t"
			"paddd %%mm7, %%mm4\n\t"
			// -V>>2
			"movq %%mm2, %%mm7\n\t"
			"psrlw $2, %%mm7\n\t"
			"psubusw %%mm7, %%mm4\n\t"
			"packuswb %%mm4, %%mm4\n\t"

		////// 	B = Y + U - 128
			"movq %%mm0, %%mm6\n\t"
			"paddd %%mm1, %%mm6\n\t"
			"psubusw %%mm5, %%mm6\n\t"
			"packuswb %%mm6, %%mm6\n\t"
	
		//////  G = Y - V>>2 -V>>5 +128>>2+128>>5  - U>>3 -U>>4 +128>>3+128>>4
			//= Y-U/8-U/16-V/4-V/32+60
			// +60 = +- 128/2
			"movq %%mm5, %%mm7\n\t"			
			"psrld $1, %%mm7\n\t"
			"paddd %%mm7, %%mm0\n\t"
			// V, $mm2
			"psrlw $2, %%mm2\n\t"
			"psubusw %%mm2, %%mm0\n\t"
			"psrlw $3, %%mm2\n\t"
			"psubusw %%mm2, %%mm0\n\t"
			// U, %mm1
			"psrlw $3, %%mm1\n\t"
			"psubusw %%mm1, %%mm0\n\t"
			"psrlw $1, %%mm1\n\t"
			"psubusw %%mm1, %%mm0\n\t"
			"packuswb %%mm0, %%mm0\n\t"


#ifdef RGB
		// Situatie:
		// 	%mm4 -> RRRR????
		// 	%mm0 -> GGGG????
		// 	%mm6 -> BBBB????
				

			//// 4 pixels wegschrijven als RGBRGBRGBRGB
		
			"movq %%mm4, %%mm1\n\t"      // %mm1=RrRr????
			"movq %%mm0, %%mm2\n\t"      // %mm2=GgGg????
			"movq %%mm6, %%mm3\n\t"      // %mm3=BbBb????

			"pxor %%mm7, %%mm7\n\t"	     // %mm7=00000000
			"punpcklbw %%mm2, %%mm1\n\t" // %mm1=RGrgRGrg
			"punpcklbw %%mm7, %%mm3\n\t" // %mm3=B0b0B0b0
			"punpcklwd %%mm3, %%mm1\n\t" // %mm1=RGB0rgb0
			
			// Situatie: %mm1=RGB0rgb0
			"movd %%mm1, %%edi\n\t"      // %edi=RGB0
			"movd %%edi, %%mm7\n\t"      // %mm7=RGB00000
			"psrlq $32, %%mm1\n\t"       // %mm1=rgb00000
			"psllq $24, %%mm1\n\t"       // %mm1=000rgb00
			"por %%mm1, %%mm7\n\t"       // %mm7=RGBrgb00
			"movq %%mm7, (%%ebx)\n\t"

			// volgende 2 pixels
			"psrlq $16, %%mm4\n\t"			
			"psrlq $16, %%mm0\n\t"			
			"psrlq $16, %%mm6\n\t"			

			"pxor %%mm7, %%mm7\n\t"	     // %mm7=00000000
			"punpcklbw %%mm0, %%mm4\n\t" // %mm4=RGrgRGrg
			"punpcklbw %%mm7, %%mm6\n\t" // %mm6=B0b0B0b0
			"punpcklwd %%mm6, %%mm4\n\t" // %mm4=RGB0rgb0

			"movd %%mm4, %%edi\n\t"
			"movd %%edi, %%mm7\n\t"
			"psrlq $32, %%mm4\n\t"
			"psllq $24, %%mm4\n\t"
			"por %%mm4, %%mm7\n\t"
			"movq %%mm7, 6(%%ebx)\n\t"

			"add $12, %%ebx\n\t"	

#endif

#ifdef RGBA			
			//// 4 pixels wegschrijven als RGBXRGBXRGBXRGBX  met X=FF
		

			"movq %%mm4, %%mm1\n\t"      // %mm1=RrRr????
			"movq %%mm0, %%mm2\n\t"      // %mm2=GgGg????
			"movq %%mm6, %%mm3\n\t"      // %mm3=BbBb????

			"pxor %%mm7, %%mm7\n\t"      // %mm7=XXXXXXXX
			
			"punpcklbw %%mm2, %%mm1\n\t" // %mm1=RGrgRGrg
			"punpcklbw %%mm7, %%mm3\n\t" // %mm3=B0b0B0b0
			"punpcklwd %%mm3, %%mm1\n\t" // %mm1=RGB0rgb0

			"psllq $8, %%mm1\n\t"   // eigenlijk wensen we ARGb ...

			"por 32(%%edx), %%mm1\n\t"
			"movq %%mm1, (%%ebx)\n\t"

			// volgende 2 pixels
			"psrlq $16, %%mm4\n\t"			
			"psrlq $16, %%mm0\n\t"			
			"psrlq $16, %%mm6\n\t"			

			"punpcklbw %%mm0, %%mm4\n\t" // %mm4=RGrgRGrg
			"punpcklbw %%mm7, %%mm6\n\t" // %mm6=B0b0B0b0
			"punpcklwd %%mm6, %%mm4\n\t" // %mm4=RGB0rgb0

			"psllq $8, %%mm4\n\t"   // eigenlijk wensen we ARGb ...

			"por 32(%%edx), %%mm4\n\t"

			
			"movq %%mm4, 8(%%ebx)\n\t"

			"add $16, %%ebx\n\t"	

#endif
			//////////////
			
			
			"add $8, %%eax\n\t"
			"dec %%ecx\n\t"
			"jnz .L99\n\t"

			"pop %%ecx\n\t"
			"pop %%ebx\n\t"

			"emms\n\n"

			:"=m"(RGB_)
			:"m"(YUV),
			"m"(NumPixels),
#ifdef RGB			
			"m"(arrays)
#endif				
#ifdef RGBA
			"m"(arraysA)
#endif				
	   );
	return 0;
}

#define YUV2RGB_(y, u, v, r, g, b)\
r = y + ((v * 1434) / 2048);\
g = y - ((u * 406) / 2048) - ((v * 595) / 2048);\
b = y + ((u * 2078) / 2048);\
r = r < 0 ? 0 : r;\
g = g < 0 ? 0 : g;\
b = b < 0 ? 0 : b;\
r = r > 255 ? 255 : r;\
g = g > 255 ? 255 : g;\
b = b > 255 ? 255 : b
#ifdef RGB
int yuv422torgb_ (char *YUV, char *RGB_, int NumPixels) {
	int i, j;
	register int y0, y1, u, v;
	register int r, g, b;

	for (i = 0, j = 0; i < 2 * NumPixels; i += 4, j += 6)
	{
		u = (unsigned char) YUV[i + 0] - 128;
		y0 = (unsigned char) YUV[i + 1];
		v = (unsigned char) YUV[i + 2] - 128;
		y1 = (unsigned char) YUV[i + 3];
		YUV2RGB_ (y0, u, v, r, g, b);
		RGB_[j + 0] = r;
		RGB_[j + 1] = g;
		RGB_[j + 2] = b;
		YUV2RGB_ (y1, u, v, r, g, b);
		RGB_[j + 3] = r;
		RGB_[j + 4] = g;
		RGB_[j + 5] = b;
	}
	return 0;
}
#endif
